(* List ⥸塼ˤʤ ListФؿ *)


(* ꥹȤΰ, a ǤΤ b ˴ޤޤʤΤ֤ *)
let rec subtract_list a b =
  match a with
    [] -> []
  | hd::tl ->
      if List.mem hd b
      then subtract_list tl b
      else hd::(subtract_list tl b)

(* l ǤΤʣƤʪ *)
let rec uniq (l:'a list) : 'a list = 
  match l with
    [] -> []
  | hd::tl -> 
      if(List.mem hd tl) then uniq tl
      else hd::(uniq tl)
		 

(* s  e ޤǤڤФ *)
let rec sub (lst:'a list) (s:int) (e:int) : 'a list = 
  if(e<=0)
  then []
  else 
    match lst with
      hd::tl ->
	if(s>0)
	then (sub tl (s-1) (e-1))
	else hd::(sub tl (s-1) (e-1))
    | [] -> []

(* ꥹȤΥץ append *)
let append2 (as1,bs1) (as2,bs2) = (as1@as2,bs1@bs2)

(* map2 Ѱǡ 夬δؿĹû˹碌 *)
let rec map2_cut (f:'a -> 'b -> 'c)  (alst:'a list) (blst:'b list) : 'c list = 
  match (alst,blst) with
    (ahd::atl, bhd::btl) ->
      (f ahd bhd)::(map2_cut f atl btl)
  | _ -> []
  
	
(* fold_left2 Ѱǡ 夬δؿĹû˹碌 *)
let rec fold_left2_cut (f:'a -> 'b -> 'c -> 'a)  (zero:'a) (blst:'b list) (clst:'c list) : 'a = 
  match (blst,clst) with
    (bhd::btl, chd::ctl) -> fold_left2_cut f (f zero bhd chd) btl ctl
  | _ -> zero
  
	
let rec assoc x lst =
  if List.mem_assoc x lst 
  then List.assoc x lst
  else failwith ("Mylist.assoc :  not found")
      

let rec cutoff_combine alst blst =
  match (alst,blst) with 
    (_,[]) -> []
  | ([],_) -> []
  | (ahd::atl,bhd::btl) -> (ahd,bhd)::(cutoff_combine atl btl)


let  indexOf v lst = 
  let rec iter n lst =
    match lst with
      hd::tl ->
	if v = hd 
	then n
	else iter (n+1) tl
    | [] -> -1
  in iter 0 lst
